"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Conversation = void 0;
const utils_1 = require("../utils");
const ConversationAnswer_1 = require("./ConversationAnswer");
const ConversationOptions_1 = require("./ConversationOptions");
class Conversation {
    constructor() {
        this.middleware = new utils_1.Middleware();
    }
    async handle(ctx, next) {
        let token = new utils_1.MiddlewareToken();
        await this.middleware.handle({ ctx, ctxNext: () => next() }, token);
        if (token.getState()) {
            return next();
        }
    }
    waitAnswer(ctx, options) {
        return new Promise(resolve => {
            let segment = this.middleware.add(async ({ ctx: upd, ctxNext: updNext }, next) => {
                var _a, _b;
                if (ctx.chat.id !== upd.chat.id) {
                    return next();
                }
                if ((options === null || options === void 0 ? void 0 : options.condition) &&
                    !(0, ConversationOptions_1.checkCondition)(upd, options.condition)) {
                    if (options === null || options === void 0 ? void 0 : options.conditionFallback) {
                        await options.conditionFallback(upd);
                    }
                    return next();
                }
                let match = (options === null || options === void 0 ? void 0 : options.condition) instanceof RegExp
                    ? (_b = (_a = upd.text) === null || _a === void 0 ? void 0 : _a.match(options.condition)) !== null && _b !== void 0 ? _b : []
                    : [];
                this.middleware.remove(segment);
                return resolve(new ConversationAnswer_1.ConversationAnswer(upd, updNext, match));
            }, `converation msg=${ctx.id}`);
        });
    }
}
exports.Conversation = Conversation;
